include <DobloFactory/doblo-factory.scad>;
include <DobloFactory/lib/doblo-params.scad>;
include <dd.scad>;

/*
The DD play: Tel-fix top piece 
@author Perrier Stéphanie, Le Coultre Régis, Borgognon Nathalie
@date 15 dec. 2015
@licence CC BY-NC-SA 4.0
*/

intersection() {
    // base and dots faces
    difference() {
        union() {
            doblo (col=$TV_DOBLO_WIDTH + $BASE_DOBLO_THICKNESS, row=$BASE_DOBLO_THICKNESS, up=$BASE_DOBLO_HEIGHT + $BASE_THICKNESS, width=$TELFIX_DOBLO_DIMENSION, length=$TELFIX_DOBLO_DIMENSION, height=$TELFIX_DOBLO_HEIGHT, nibbles_on_off=false, diamonds_on_off=false, scale=LUGO);
            
            // add 4 dots dice face wall thickness  (ceiling)
            block (col=$TV_DOBLO_WIDTH + $BASE_DOBLO_THICKNESS, row=0, up=$BASE_DOBLO_HEIGHT + $BASE_THICKNESS + $TV_DOBLO_HEIGHT, width=$TV_DOBLO_WIDTH + $BASE_DOBLO_THICKNESS, length=$TELFIX_DOBLO_DIMENSION + $BASE_DOBLO_THICKNESS, height=($BASE_THICKNESS/8) * 7, nibbles_on_off=false, diamonds_on_off=false, scale=LUGO);
            
            // add 5 dots dice face wall thickness
            block (col=$TV_DOBLO_WIDTH + $BASE_DOBLO_THICKNESS + $TELFIX_DOBLO_DIMENSION, row=0, up=$BASE_DOBLO_HEIGHT + $BASE_THICKNESS, width=$BASE_DOBLO_THICKNESS, length=$TELFIX_DOBLO_DIMENSION + $BASE_DOBLO_THICKNESS, height=$TV_DOBLO_HEIGHT, nibbles_on_off=false, diamonds_on_off=false, scale=LUGO);
            
            // add 6 dots dice face wall thickness
            block (col=$TV_DOBLO_WIDTH + $BASE_DOBLO_THICKNESS, row=0, up=$BASE_DOBLO_HEIGHT + $BASE_THICKNESS, width=$TV_DOBLO_WIDTH + $BASE_DOBLO_THICKNESS, length=$BASE_DOBLO_THICKNESS, height=$TV_DOBLO_HEIGHT, nibbles_on_off=false, diamonds_on_off=false, scale=LUGO);
        }
        
        // 6 dots dice face
        rotate([-90,0,0]) {
            dotsFactory(topLeftDot=true, topRightDot=true, middleLeftDot=true, middleCenterDot=false, middleRightDot=true, bottomLeftDot=true, bottomRightDot=true);
        }
        
        // 5 dots dice face
        translate([$BASE_DIMENSION, 0, 0]) {
            rotate([-90,0,-90]) {
                dotsFactory(topLeftDot=true, topRightDot=true, middleLeftDot=false, middleCenterDot=true, middleRightDot=false, bottomLeftDot=true, bottomRightDot=true);
            }
        }
        
        // 4 dots dice face
        translate([0, 0, 1.6 * ($BASE_DOBLO_HEIGHT + ($BASE_THICKNESS / 2) * 3.5 + $TV_DOBLO_HEIGHT)]) {
            dotsFactory(topLeftDot=true, topRightDot=true, middleLeftDot=false, middleCenterDot=false, middleRightDot=false, bottomLeftDot=true, bottomRightDot=true);
        } 
    }
    
    // Apply chamfers
    xChamfer();
    yChamfer();
    zChamfer();
}
