include <DobloFactory/doblo-factory.scad>;
include <DobloFactory/lib/doblo-params.scad>;
include <dd.scad>;

/*
The DD play: TV Basic top piece 
@author Perrier Stéphanie, Le Coultre Régis, Borgognon Nathalie
@date 15 dec. 2015
@licence CC BY-NC-SA 4.0
*/

// base and dots faces
difference() {
    union() {
        doblo (col=0, row=0, up=$BASE_DOBLO_HEIGHT, width=$TV_DOBLO_WIDTH, length=$TV_DOBLO_LENGTH, height=$TV_DOBLO_HEIGHT, nibbles_on_off=false, diamonds_on_off=false, scale=LUGO);
        
        translate([8,-8-16,($BASE_DOBLO_HEIGHT + $TV_DOBLO_HEIGHT + 1.2)]) {
            cube([8,8,$TV_DOBLO_HEIGHT*1.6],center=false);
        }


    translate([0,-16,($BASE_DOBLO_HEIGHT + $TV_DOBLO_HEIGHT  + 1.2)]) {
        cube([8,8,$TV_DOBLO_HEIGHT*1.6],center=false);
        }
    }
        
    // 6 dots dice face
    rotate([-90,0,0]) {
        dotsFactory(topLeftDot=true, topRightDot=true, middleLeftDot=true, middleCenterDot=false, middleRightDot=true, bottomLeftDot=true, bottomRightDot=true);
    }
    
    // 2 dots dice face
    rotate([-90,0,-90]) {
        dotsFactory(topLeftDot=false, topRightDot=true, middleLeftDot=false, middleCenterDot=false, middleRightDot=false, bottomLeftDot=true, bottomRightDot=false);
    } 

    // 4 dots dice face
    translate([0, 0, 1.6 * ($BASE_DOBLO_HEIGHT + $TV_DOBLO_HEIGHT)]) {
        dotsFactory(topLeftDot=true, topRightDot=true, middleLeftDot=false, middleCenterDot=false, middleRightDot=false, bottomLeftDot=true, bottomRightDot=true);
    } 
}


  


